#include <libce.h>
#include <vm.h>

// Facciamo la stessa cosa di vm1, ma usando map()
int x = 0;

paddr base_px;

// funzione da passare come ultimo argomento di map()
// (si veda più avanti)
paddr mappa_x(vaddr) { return base_px; }

void main()
{
	vaddr v = norm(04443332221110000);

	paddr px = trasforma(readCR3(), int_cast<vaddr>(&x));

	base_px = px & ~0xFFF;

	paddr tab4 = readCR3();

	/*
	paddr tab3 = alloca_tab();
	paddr tab2 = alloca_tab();
	paddr tab1 = alloca_tab();

	tab_entry& e4 = get_entry(tab4, 0444);
	tab_entry& e3 = get_entry(tab3, 0333);
	tab_entry& e2 = get_entry(tab2, 0222);
	tab_entry& e1 = get_entry(tab1, 0111);

	e4 = tab3    | BIT_P | BIT_RW;
	e3 = tab2    | BIT_P | BIT_RW;
	e2 = tab1    | BIT_P | BIT_RW;
	e1 = base_px | BIT_P | BIT_RW;
	*/
	// map() si occupa di allocare e modificare tutte le tabelle e le
	// entrate necessarie, sostanzialmente evitandoci il lavoro che avevamo
	// fatto negli altri esempi e riportato nel commento qui sopra.
	// Inoltre, map() è in grado di farlo per un intero intervallo, e non
	// solo per una pagina alla volta.  In questo esempio l'intervallo è
	// comunque di una sola pagina (da v a v+DIM_PAGINA escluso).
	//
	// map() ha bisogno di sapere quali bit vogliamo settare (oltre ai bit
	// P) e quali indirizzi fisici vogliamo associare ad ogni indirizzo
	// virtuale dell'intervallo. Per dirle la seconda cosa le passiamo una
	// funzione che riceve un indirizzo virtuale e deve restituire
	// l'indirizzo fisico che vogliamo associarvi.  In questo caso, visto
	// che stiamo mappando un'unica pagina, la nostra funzione verrà
	// chiamata una sola volta, per l'indirizzo v, e deve restituire
	// base_px.
	map(tab4, v, v + DIM_PAGINA, BIT_RW, &mappa_x);

	natq offset_px = px & 0xFFF;
	vaddr vx = v | offset_px;

	int *p = ptr_cast<int>(vx);

	printf("*p prima dell'assegnamento: %d\n", *p);
	x = 1;
	printf("*p dopo l'assegnamento: %d\n", *p);
	pause();

}
